CFLAGS := -g -Wall -Wno-unused-variable -Wno-unused-but-set-variable -Werror
CXXFLAGS := $(CFLAGS) -std=c++0x
CC := g++

SOURCES := array.c hash.c maca_alphabet.cc maca_alphabet_wrapper.cc maca_common.c maca_graph_parser_alphabet.c maca_graph_parser.c maca_graph_parser_conll2007_format.c maca_graph_parser_corpora.c maca_graph_parser_decoder1.c maca_graph_parser_decoder2.c maca_graph_parser_decoder.c maca_graph_parser_dep_count_table.c maca_graph_parser_feature_counter_array.c maca_graph_parser_feature_counter.c maca_graph_parser_features.c maca_graph_parser_feature_table.c maca_graph_parser_feature_vector.c maca_graph_parser_hash.c maca_graph_parser_heapq.c maca_graph_parser_hyperdecoder.c maca_graph_parser_hypergraph.c maca_graph_parser_metrics.c maca_graph_parser_model.c maca_graph_parser_sentence.c maca_mcf.cc maca_mcf_wrapper.cc maca_msg.c simple_parser.cc maca_graph_parser_train.c
OBJ:= $(patsubst %.cc, %.o, $(patsubst %.c, %.o, $(SOURCES)))
EXE := test_simple_parser maca_graph_parser_decode maca_graph_parser_eval maca_graph_parser maca_graph_parser_print_model maca_graph_parser_resize_model maca_graph_parser_train

all: $(EXE)

test_simple_parser: test_simple_parser.o $(OBJ)
maca_graph_parser_decode: maca_graph_parser_decode_main.o $(OBJ)
maca_graph_parser_eval: maca_graph_parser_eval_main.o $(OBJ)
maca_graph_parser: maca_graph_parser_main.o $(OBJ)
maca_graph_parser_print_model: maca_graph_parser_print_model_main.o $(OBJ)
maca_graph_parser_resize_model: maca_graph_parser_resize_model_main.o $(OBJ)
maca_graph_parser_train: maca_graph_parser_train_main.o $(OBJ)

%.o: %.c
	gcc $(CFLAGS) -c $<

%: %_main.o $(OBJ)
	g++ $(CFLAGS) -o $@ $^

clean:
	rm -f $(EXE) *.o
